; --------------------------------------
; /wlan v1.0 - by Flobse
;
; This addon supports the Linksys Router WRT54GL and WRT54G (maybe also other Linksys router).
; You can use this addon to change the WLAN status (on/off) via mIRC, if you use one of this routers.
;
; Dont forget to change your password in the first alias.
;
; Have Fun!
;
; --------------------------------------
; Syntax: /wlan [on|off|B|G]
;
; Without parameter it does show you the current wlan status.
; /wlan on will use the "mixed" mode as default.
;
; --------------------------------------
; ## #Flobse @ Quakenet - Scripter@Flobse.de - UIN: 152759920 ##



alias -l router.settings {
  if ($1 == Password) { return YourRouterPassword }
  if ($1 == RouterIP) { return 192.168.1.1 }
  if ($1 == SSL) { return 0 } ;1 = SSL, 0 = Normal connection
}

alias wlan {
  if (!$1) || ($1 == on) || ($1 == off) || ($1 == g) || ($1 == b) {
    if (!$sslready) && ($router.settings(SSL)) { 
      if ($input(Your Mirc does not support SSL-Connections. $crlf $+ Do you want to read how you can use SSL with mIRC?,-yw,WLAN Remote)) { .url www.mirc.com/ssl.html }
      return 
    }
    sockclose router*
    sockopen $iif($router.settings(SSL),-e) routerget $router.settings(RouterIP) $iif($router.settings(SSL),443,80)
    sockmark routerget $replacex($iif($1,$1,status),on,mixed,off,disabled,g,g-only,b,b-only)
  }
  else { echo -a * /wlan wrong parameter. Use /wlan [on|off|B|G] (Note: /wlan on will use "mixed" as Wlan-mode) }
} 

on *:sockopen:routerget: {
  if ($sockerr) { echo -a Cant find Router - Check the IP ( $+ $router.settings(RouterIP) $+ ) | return }
  sockwrite -n $sockname GET /Wireless_Basic.asp HTTP/1.1
  sockwrite -n $sockname Host: $router.settings(RouterIP)
  sockwrite -n $sockname Authorization: Basic $encode(: $+ $router.settings(Password),m)
  sockwrite -n $sockname
}

on *:sockread:routerget: {
  var %t | sockread %t
  if ($regex(%t,/<option value."(.+?)" selected></ig)) && ($sock($sockname).mark == status) { 
    echo -a WLAN Status: $iif($regml(1) != disabled,ON,OFF) ( $+ $regml(1) $+ ) 
    sockclose $sockname
  }
  if ($sock($sockname).mark != status) {
    if ($regex(%t,/value='(.+?)' name="wl_ssid"/ig)) { set -u3 %router &wl_ssid= $+ $regml(1) }
    if ($regex(%t,/var wl_channel = '(\d)'/ig)) { set -u3 %router %router $+ &wl_channel= $+ $regml(1) }
    if ($regex(%t,/value=(\d) name=wl_closed/ig)) { 
      set -u3 %router %router $+ &wl_closed= $+ $regml(1) 
      sockopen $iif($router.settings(SSL),-e) routerset $router.settings(RouterIP) $iif($router.settings(SSL),443,80)
      sockmark routerset $sock($sockname).mark
      sockclose $sockname
} } }

on *:sockopen:routerset: {
  if ($sockerr) { echo -a Cant change Router-Settings - Check the IP ( $+ $router.settings(RouterIP) $+ ) | return }
  if (%router) {
    var %s submit_button=Wireless_Basic&action=Apply&submit_type=&change_action=&next_page=&wl_net_mode= $+ $sock($sockname).mark $+ %router
    sockwrite -n $sockname POST /apply.cgi HTTP/1.1
    sockwrite -n $sockname Host: $router.settings(RouterIP)
    sockwrite -n $sockname Authorization: Basic $encode(: $+ $router.settings(Password),m)
    sockwrite -n $sockname Content-Type: application/x-www-form-urlencoded
    sockwrite -n $sockname Content-Length: $len(%s)
    sockwrite -n $sockname
    sockwrite -n $sockname %s
} }

on *:sockread:routerset: { wlan | sockclose $sockname }
